# Hyperspectral Fourier-Mellin algorithm (HYFM)

## Dependencies

* Install: `sudo apt-get install liblapacke-dev libmatio-dev`

## How to register

Run `./HYFM-reg` with the following parameters:

`./HYFM-reg <reference_image.mat> <target_image.mat>`

Outputs:

* Textual result in console: scale, angle of rotation, and shifts over x and y axis.
* Original band 0 of reference and target images in PGM format.
* Registered band 0 image in PGM format.
* Registered hyperspectral image in MAT format.

## Additional program

`rot_scal` allows generating new target images with specific a scale and angle of rotation for testing the performance of the method.

Use:

`./rot_scal <image.mat> <scale> <angle>`

The output image is saved in the same directory with the name `rot_scal_out.mat`.

## Examples

Using Santa Barbara Line images:

`./HYFM-reg SantaBarbaraLine2013.mat SantaBarbaraLine2014.mat`

Using Pavia University image:

1. `./rot_scal PaviaUniversity.mat 2.0 90`
2. `./HYFM-reg PaviaUniversity.mat ./rot_scal_out.mat`

## Citation

This algorithm was presented in the paper "Fourier-Mellin registration of two hyperspectral images". If you use this program in your research projects, we encourage you to please cite our work:

```
@article{alvaroordonez2017fouriermellin,
    title = {Fourier-Mellin registration of two hyperspectral images},
    journal = {International Journal of Remote Sensing},
    volume = {38},
    number = {11},
    year = {2017},
    pages = {3253-3273},
    doi = {10.1080/01431161.2017.1292071},
    url = {http://dx.doi.org/10.1080/01431161.2017.1292071},
    author = {\'{A}lvaro Ord\'{o}\~{n}ez and Francisco Arg\"{u}ello and Dora B. Heras}
}
```
